% 2_D-FEM for Laplace-operator
clear all;
close all;


% Initialisation
addpath Square
load coordinates.dat; coordinates=coordinates(:,2:end);
load elements.dat; elements=elements(:,2:end);
load dirichlet.dat; dirichlet=dirichlet(:,2:end);



% display the grid
figure(1)
trisurf(elements,coordinates(:,1), coordinates(:,2), 0*coordinates(:,2),...
        'facecolor','interp', 'Marker','.');
grid off; axis equal; view(2)


BdryNodes = unique(dirichlet);
FreeNodes=setdiff(1:size(coordinates,1),BdryNodes);
A = sparse(size(coordinates,1),size(coordinates,1));
b = sparse(size(coordinates,1),1);

% Assembly
for j = 1:size(elements,1)
  A(elements(j,:),elements(j,:)) = A(elements(j,:),elements(j,:)) ...
      + stima3(coordinates(elements(j,:),:));
end

% Volume Forces
for j = 1:size(elements,1)
  b(elements(j,:)) = b(elements(j,:)) + ...
    %
    % HIER APPROXIMATIVE BERECHNUNG VON \int_Ti  f*p_i dx 
    %
end

% Dirichlet conditions
u = sparse(size(coordinates,1),1);
u(unique(dirichlet)) = u_d(coordinates(unique(dirichlet),:));

b = b - A * u;

% Computation of the solution
u(FreeNodes) = A(FreeNodes,FreeNodes) \ b(FreeNodes);


% graphic representation
figure(2);
trisurf(elements,coordinates(:,1),coordinates(:,2),u','facecolor','interp')
view(10,40);     
title('Solution of the Problem')